#!/usr/bin/perl -w
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# Version 0.1
######################################
use XML::Writer;
use POSIX qw(strftime);
use File::Basename;
use IO::File;
use XML::Simple;
use strict;
######################################
#
fileparse_set_fstype("MSWin32");
my $rnd=int(rand(9956) + 10000); #Random number for GUID
my $writer = XML::Writer->new(UNSAFE=>1,DATA_MODE=>1,DATA_INDENT=>1);
my $dispDate = strftime('%d %Y %H:%M:%S %Z', localtime);
#$dispDate= "Sun, ".$dispDate." GMT";
#my $dispDate="Mon, 11 Jan 2010 13:00:00 GMT";
my ($path, $file);
my ($fileName, $filePath, $fileSuffix);
my $weatherSlice = 0; # how many times the Weather picutes comes, 0 = only ones
my $countPic = 72; # how many picutes in a feed, 100 = default max
my $itemCount = 0;
my $weatherPath = "";
my $foundTime;
my $n = 0;
my $curTime= strftime('%H', localtime);
my $config = XML::Simple->new(forcearray => 0)->XMLin('D:/Inetpub/wwwroot/apache/rss-photos/home.xml');
######################################
# get values from xml file
foreach (sort @{$config->{'from'}}) {
  if($curTime ge $config->{'from'}->[$n]->{'time'}) { $foundTime = $n; }
    $n++;
}
if (! defined $foundTime) { $foundTime = $n - 1; } # no match found, take the last record
my %duration = ('W' => $config->{'from'}->[$foundTime]->{'duration'}->{'W'},
                'WR'=> $config->{'from'}->[$foundTime]->{'duration'}->{'WR'},
                'A' => $config->{'from'}->[$foundTime]->{'duration'}->{'A'},
                'AR'=> $config->{'from'}->[$foundTime]->{'duration'}->{'AR'},
                'B' => $config->{'from'}->[$foundTime]->{'duration'}->{'B'},
                'BR'=> $config->{'from'}->[$foundTime]->{'duration'}->{'BR'},
                'P' => $config->{'from'}->[$foundTime]->{'duration'}->{'P'},
                'PN'=> $config->{'from'}->[$foundTime]->{'duration'}->{'PN'},
                'X' => 60);
######################################
# Build rss header
$writer->xmlDecl('utf-8');
#$writer->raw('<?xml version="1.0" encoding="utf-8" ?>');
#print "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n";
$writer->startTag('rss', 'version'=>'2.0', 'xmlns:media'=>'http://search.yahoo.com/mrss/');
$writer->startTag('channel');
#print "\n";
$writer->startTag('title'); $writer->characters('Private feed'); $writer->endTag();
$writer->startTag('link'); $writer->characters('http://themax.se'); $writer->endTag();
$writer->startTag('description'); $writer->characters('Pictures'); $writer->endTag();
$writer->startTag('ttl'); $writer->characters('1'); $writer->endTag();
$writer->startTag('lastBuildDate'); $writer->characters("$dispDate");$writer->endTag();
#####################################
# sub to print each <item>
# input filename incl path
sub printItem {
  $path = shift;
  ($fileName, $filePath, $fileSuffix) = fileparse( $path, "\.[^.]*");
  $writer->startTag('item');
  $writer->startTag('title'); $writer->characters("Picture $itemCount"); $writer->endTag();
  $writer->startTag('link'); $writer->characters("http://themax.se/rss-photos/pics/$fileName$fileSuffix"); $writer->endTag();
  $writer->startTag('category'); $writer->characters('Pictures'); $writer->endTag();
  $writer->startTag('description'); $writer->raw("&lt;img src=&quot;http://themax.se/rss-photos/pics/$fileName$fileSuffix&quot;width=&quot;800&quot;&gt;"); $writer->endTag();
#  $writer->startTag('description'); $writer->raw("&lt;img src=&quot;http://themax.se/rss-photos/pics/$fileName$fileSuffix&quot;width=&quot;40&quot;&gt;"); $writer->endTag();
  $writer->startTag('guid', 'isPermaLink'=>'false');
  $path =~ s|\D||g; # get only the digits from file name
  $rnd=int(rand(9956) + 10000); #Random number for GUID
  $path=int(rand(9956) + 10000); #Random number for GUID
  $writer->characters("$path-$itemCount-$rnd");
  $writer->endTag('guid');
  $writer->emptyTag('media:content', 'url'=>"http://themax.se/rss-photos/pics/$fileName$fileSuffix", 'type'=>'media/jpeg', 'duration'=>"$duration{substr($fileName,0,1)}");
  $writer->endTag('item');
}
#####################################
# mail loop
open LOGFILE,">>rss-req.log";
print LOGFILE "$dispDate\n";
my @files = <D:\\Inetpub\\wwwroot\\apache\\rss-photos\\pics\\*>;
#print STDERR @files;
#print LOGFILE "\nCurrtime=$curTime\n";
$weatherSlice = $duration{'WR'};
if (defined $duration{'PN'}) { $countPic = $duration{'PN'} + 1; }
foreach $file (reverse sort @files) {
  ($fileName, $filePath, $fileSuffix) = fileparse( $file, "\.[^.]*");
  #print LOGFILE "countPic:$countPic file=$fileName\n";
  if ($fileName eq "") {
	    #print STDERR "File with no name:$fileName, countPic=$countPic, duration=$duration{'P'}\n";
  
	  next;
  }
  if ($countPic eq "0") { last;}
  if(substr($fileName,0,1) eq 'P' and $countPic and defined $duration{'P'}) { # print only if P defined
    #print STDERR "File with P found $file, countPic=$countPic, duration=$duration{'P'}\n";
    $itemCount++;
    printItem($file);
  } elsif(substr($fileName,0,1) eq 'W' and defined $duration{'W'}) {
    $itemCount++;
	#print STDERR "Weather: $fileName, countPic=$countPic, duration=$duration{'WR'}\n";

    printItem($file);
    if(length($weatherPath) == 0) { $weatherPath = $file; } # first time we find
  } elsif(substr($fileName,0,1) eq 'X') { # receipt picture available
    printItem($file);
    last; # no more slides if we got a receipt picture
  }
  if (! --$weatherSlice) { # time to slice in a weather again
      #print STDERR "Weatherslice=$weatherSlice $fileName, countPic=$countPic, duration=$duration{'WR'}\n";
    $itemCount++;
    #print LOGFILE "countPic:$countPic file=Weather\n";
    $weatherSlice = $duration{'WR'} - 1; # less one
    printItem($weatherPath);
  }
  if($countPic) { $countPic--; }
}
$writer->endTag();
####################################
# and now the end
$writer->endTag();
$writer->end();
close LOGFILE;

